<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <suspense-query
    :query="versionDescriptionChangesQuery"
    transition="fade"
    transition-mode="out-in"
    :delay-loading="500"
  >
    <!-- Loading -->

    <template #loading>
      <v-skeleton-loader type="paragraph" />
    </template>

    <!-- Error -->

    <template #error>
      <v-alert class="studium-alert" dense text type="error">
        {{ versionDescriptionChangesQueryError.message }}
      </v-alert>
    </template>

    <!-- Data -->

    <template #data>
      <div v-dompurify-html="versionDescriptionChanges" />
    </template>
  </suspense-query>
</template>

<script lang="ts">
import { computed, defineComponent } from '@nuxtjs/composition-api'

import { useCourseDescriptionVersionChangesQuery } from '~/apollo/_generated'
import { useErrorHandler } from '~/util/composables/'

export default defineComponent({
  props: {
    // Version to show
    version: {
      type: Object,
      required: true,
    },
  },
  setup(props) {
    // Version info
    const versionDescriptionChangesQuery = useCourseDescriptionVersionChangesQuery(
      { id: props.version.id },
      { fetchPolicy: 'no-cache' }
    )
    const versionDescriptionChangesQueryError = useErrorHandler(versionDescriptionChangesQuery)
    const versionDescriptionChanges = computed(
      () => versionDescriptionChangesQuery.result.value?.courseDescriptionVersionById?.changes ?? []
    )

    return {
      versionDescriptionChangesQuery,
      versionDescriptionChangesQueryError,
      versionDescriptionChanges,
    }
  },
})
</script>
